//-----------------------------------------------------------------------------
// Title      : bsp_ub038_mk3_ext_eth1
//-----------------------------------------------------------------------------
// Funktion   : Externes Modul : Ethernet-Modul mit ENC28J60
// Schaltung  : myAVR MK3 + ETH-Modul
//-----------------------------------------------------------------------------
// Prozessor  : ATMega2560
// Takt       : 16 MHz
// Sprache    : C
// Date       : 16.12.2011
// Version    : 1.0
// Autor      : UB
//-----------------------------------------------------------------------------
#define F_CPU 16000000
#include <avr/io.h>
#include <ub_mk3_2560/MK3_2560_LCD.h>
#include <ub_ext_module/EXT_MOD_ETH.h>


//-----------------------------------------------------------------------------
// Hinweis : Quick-Jumper Port-C+A muss gesetzt sein
// - das Ethernet-Modul muss angeschlossen sein
// - das Programm prueft ob der ENC28J60 funktioniert
//   und zeigt die gelesene PHID1 und PHID2 Nummer an
//  (sonst hat das Programm keine weitere Funktion)
//-----------------------------------------------------------------------------
int main (void)
{
	MK3_INIT_LCD();					// init des LCD
	
	MK3_LCD_CLEAR();				// LCD loeschen
	MK3_LCD_LIGHT(true);			// beleuchtung einschalten
	
    MK3_LCD_STRING_AT(0,0,"ETH-Modul Test:01");
    
    EXT_INIT_ETH();
    if(ENC28J60.status_ok==true) {
      MK3_LCD_STRING_AT(0,16,"ENC28J60 OK");
    }
    else {
      MK3_LCD_STRING_AT(0,16,"ENC28J60 Error");
      MK3_LCD_STRING_AT(0,24,"> Hardware pruefen !");
    }
    
    MK3_LCD_STRING_AT(0,32,"PHID1=");
    MK3_LCD_PRINT_UTYP(ENC28J60.phid1,HEX_U4);
    MK3_LCD_STRING_AT(0,40,"PHID2=");
    MK3_LCD_PRINT_UTYP(ENC28J60.phid2,HEX_U4);
    
    MK3_LCD_STRING_AT(0,56,"Modul ohne Funktion");
    
	while (true)
	{

	}
	return 0;
}
//-----------------------------------------------------------------------------
