unit Main_Form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Thales, Tasten, ping_ub, IdBaseComponent,
  IdComponent, IdUDPBase, IdUDPServer,IdSocketHandle, ExtCtrls, Thalmisc;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    StatusBar: TStatusBar;
    GroupBox1: TGroupBox;
    UDPPort: TEdit;
    GroupBox4: TGroupBox;
    UDPServer: TIdUDPServer;
    BtnOpen: TButton;
    BtnClose: TButton;
    LedEth: TLedCheck;
    GroupBox3: TGroupBox;
    OwnIP: TEdit;
    GroupBox2: TGroupBox;
    OwnMac: TEdit;
    GroupBox5: TGroupBox;
    Send_CMD: TEdit;
    BtnSend: TButton;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel3: TPanel;
    Panel4: TPanel;
    GroupBox6: TGroupBox;
    Memo_TX: TMemo;
    Panel5: TPanel;
    CB_TX_en: TCheckBox;
    Btn_TX_CLR: TButton;
    Panel6: TPanel;
    Panel7: TPanel;
    CB_RX_en: TCheckBox;
    Btn_RX_CLR: TButton;
    Panel8: TPanel;
    GroupBox7: TGroupBox;
    Memo_RX: TMemo;
    Label2: TLabel;
    Timer_Tx: TPrecTimer;
    Timer_Rx: TPrecTimer;
    LED_TxD: TLedCheck;
    LED_RxD: TLedCheck;
    GroupBox8: TGroupBox;
    ClientIP: TEdit;
    OwnIPList: TListBox;
    OwnMacList: TListBox;
    BtnPing: TButton;
    PingList: TListBox;
    BtnClr: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure BtnOpenClick(Sender: TObject);
    procedure BtnCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure UDPServerUDPRead(Sender: TObject; AData: TStream;
      ABinding: TIdSocketHandle);
    procedure Btn_TX_CLRClick(Sender: TObject);
    procedure Btn_RX_CLRClick(Sender: TObject);
    procedure Timer_TxTimer(Sender: TObject; Time: Cardinal);
    procedure Timer_RxTimer(Sender: TObject; Time: Cardinal);
    procedure BtnSendClick(Sender: TObject);
    procedure BtnPingClick(Sender: TObject);
    procedure BtnClrClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormActivate(Sender: TObject);
var
  s : string;
  n : integer;
begin
  PageControl1.ActivePageIndex:=0;
  StatusBar.Panels[0].Text:='Server = inaktiv';
  s:=LocalInternetIP();
  if(s<>'Unknown IP') then begin
    OwnIP.Text:=s;
    StatusBar.Panels[2].Text:='IP = '+s;
  end
  else begin
    s:='127.0.0.1';
    OwnIP.Text:=s;
    StatusBar.Panels[2].Text:='IP = '+s;
    BtnOpen.Enabled:=false;
  end;
  s:=LocalMacAdr();
  OwnMac.Text:=s;
  StatusBar.Panels[3].Text:='MAC = '+s;

  OwnIPList.Items.Clear;
  if(ip_list.Count>0) then begin
    for n:=1 to ip_list.Count do begin
      s:=ip_list.Strings[n-1];
      OwnIPList.Items.Add(s);
    end;
  end;

  OwnMacList.Items.Clear;
  if(mac_list.Count>0) then begin
    for n:=1 to mac_list.Count do begin
      s:=mac_list.Strings[n-1];
      OwnMacList.Items.Add(s);
    end;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UDPServer.Active:=false;
  UDPServer.Bindings.Clear;
end;

procedure TForm1.BtnOpenClick(Sender: TObject);
var
  s : String;
  i : integer;
begin
  i:=strtoint(UDPPort.Text);
  if(i>0) then begin
    LedEth.Checked:=true;
    s:='[Port='+UDPPort.Text+']';
    StatusBar.Panels[0].Text:='UDP aktiv '+s;
    UDPServer.DefaultPort:=strtoint(UDPPort.Text);
    UDPServer.Active:=true;
    UDPPort.Enabled:=false;
    BtnClose.Enabled:=true;
    BtnOpen.Enabled:=false;
    BtnSend.Enabled:=true;
    ClientIP.Enabled:=false;
  end;
end;

procedure TForm1.BtnCloseClick(Sender: TObject);
begin
  LedEth.Checked:=false;
  StatusBar.Panels[0].Text:='Server = inaktiv';
  UDPServer.Active:=false;
  UDPServer.Bindings.Clear;
  UDPPort.Enabled:=true;
  BtnClose.Enabled:=false;
  BtnOpen.Enabled:=true;
  BtnSend.Enabled:=false;
  ClientIP.Enabled:=true;
end;



procedure TForm1.UDPServerUDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);
var
  s: string;
  StrStream: TStringStream;
begin
  text:='';
  StrStream := TStringStream.Create('');
  try
    StrStream.CopyFrom(AData, AData.Size);
    if(CB_RX_en.Checked=true) then begin
      s := StrStream.DataString;
      Memo_RX.Lines.Add(s);
      LED_RxD.Checked:=true;
      Timer_Rx.Enabled:=true;
    end;
  finally
    StrStream.Free;
  end;
end;


procedure TForm1.Btn_TX_CLRClick(Sender: TObject);
begin
  Memo_TX.Clear;
end;

procedure TForm1.Btn_RX_CLRClick(Sender: TObject);
begin
  Memo_RX.Clear;
end;

procedure TForm1.Timer_TxTimer(Sender: TObject; Time: Cardinal);
begin
  // led ausschalten
  Timer_Tx.Enabled:=false;
  LED_TxD.Checked:=false;
end;

procedure TForm1.Timer_RxTimer(Sender: TObject; Time: Cardinal);
begin
  // led ausschalten
  Timer_Rx.Enabled:=false;
  LED_RxD.Checked:=false;
end;

procedure TForm1.BtnSendClick(Sender: TObject);
var
  s:string;
  s_clientip:string;
  s_udpport:integer;
begin
  s:=Send_CMD.Text;
  if(s<>'') then begin
    s_udpport:=strtoint(UDPPort.Text);
    s_clientip:=ClientIP.Text;
    UDPServer.Send(s_clientip,s_udpport,s);
    if(CB_TX_en.Checked=true) then begin
      Memo_TX.Lines.Add(s);
      LED_TxD.Checked:=true;
      Timer_Tx.Enabled:=true;
    end;
  end;
end;

procedure TForm1.BtnPingClick(Sender: TObject);
var
  n : integer;
  s : string;
begin
  s:=ClientIp.Text;
  PingList.Items.Add('Ping to '+s);
  n:=PingDW(DNSNameToIp(s));
  if(n>-1) then begin
    PingList.Items.Add(IntToStr(n)+' ms');
  end
  else begin
    PingList.Items.Add('no echo');
  end;
end;

procedure TForm1.BtnClrClick(Sender: TObject);
begin
  PingList.Items.Clear;
end;

end.
