unit ping_ub;

interface
uses winsock, windows,SysUtils,NB30,Classes;

function IcmpCreateFile : THandle; stdcall; external 'icmp.dll';  
function IcmpCloseHandle (icmpHandle : THandle) : boolean; stdcall; external 'icmp.dll'
function IcmpSendEcho  
   (IcmpHandle : THandle; DestinationAddress : In_Addr;  
    RequestData : Pointer; RequestSize : Smallint;  
    RequestOptions : pointer;
    ReplyBuffer : Pointer;  
    ReplySize : DWORD;  
    Timeout : DWORD) : DWORD; stdcall; external 'icmp.dll';

 
function GetRTTAndHopCount(DestIpAddress:DWORD; HopCount :pointer; MaxHops: DWORD;  
    RTT : pointer):boolean; stdcall; external 'iphlpapi.dll';  

 
function GetIPAddress(const HostName: string): string;  
function LocalInternetIP: string;
function LocalMacAdr:string;
function ICMPPing(Ip : DWORD) : boolean;  
function DNSNameToIp(host: string):DWORD;  
function PingDW(ip: dword):integer;  

var
  ip_list : TStrings;
  mac_list : TStrings;


implementation

function GetIPAddress(const HostName: string): string;  
var  
  R: Integer;  
  WSAData: TWSAData;  
  HostEnt: PHostEnt;  
  Host: string;  
  SockAddr: TSockAddrIn;  
begin  
  Result := '';  
  R := WSAStartup($0101, WSAData);  
  if R = 0 then  
    try  
      Host := HostName;  
      if Host = '' then  
      begin  
        SetLength(Host, MAX_PATH);  
        GetHostName(@Host[1], MAX_PATH);  
      end;  
      HostEnt := GetHostByName(@Host[1]);  
      if HostEnt <> nil then  
      begin  
        SockAddr.sin_addr.S_addr := Longint(PLongint(HostEnt^.h_addr_list^)^);  
        Result := inet_ntoa(SockAddr.sin_addr);  
      end;  
    finally  
      WSACleanup;  
    end;  
end;  

function LocalInternetIP : string;
type
  TaPInAddr = array [0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var phe : PHostEnt;
  pptr : PaPInAddr;
  Buffer : array [0..63] of char;
  I : Integer;
  GInitData : TWSADATA;
begin
  ip_list := TStringList.Create;
  ip_list.Clear;
  WSAStartup($101, GInitData);
  Result := '';
  GetHostName(Buffer, SizeOf(Buffer));
  phe :=GetHostByName(buffer);
  if phe = nil then begin
    result:='Unknown IP';
    exit;
  end;
  pptr := PaPInAddr(Phe^.h_addr_list);
  I := 0;
  while pptr^[I] <> nil do begin
    result:=StrPas(inet_ntoa(pptr^[I]^));
    Inc(I);
    ip_list.Add(IntToStr(i)+'='+result);
  end;
  WSACleanup;
end;

function LocalMacAdr: string;
var
  NCB: PNCB;
  Adapter: PAdapterStatus;

//  URetCode: PChar;
  RetCode: char;
  I: integer;
  Lenum: PlanaEnum;
  _SystemID: string;
//  TMPSTR: string;
begin
  mac_list := TStringList.Create;
  mac_list.Clear;
  Result    := '';
  _SystemID := '';
  Getmem(NCB, SizeOf(TNCB));
  Fillchar(NCB^, SizeOf(TNCB), 0);

  Getmem(Lenum, SizeOf(TLanaEnum));
  Fillchar(Lenum^, SizeOf(TLanaEnum), 0);

  Getmem(Adapter, SizeOf(TAdapterStatus));
  Fillchar(Adapter^, SizeOf(TAdapterStatus), 0);

  Lenum.Length    := chr(0);
  NCB.ncb_command := chr(NCBENUM);
  NCB.ncb_buffer  := Pointer(Lenum);
  NCB.ncb_length  := SizeOf(Lenum);
  RetCode         := Netbios(NCB);

  i := 0;
  repeat
    Fillchar(NCB^, SizeOf(TNCB), 0);
    Ncb.ncb_command  := chr(NCBRESET);
    Ncb.ncb_lana_num := lenum.lana[I];
    RetCode          := Netbios(Ncb);

    Fillchar(NCB^, SizeOf(TNCB), 0);
    Ncb.ncb_command  := chr(NCBASTAT);
    Ncb.ncb_lana_num := lenum.lana[I];
    // Must be 16
    Ncb.ncb_callname := '*               ';

    Ncb.ncb_buffer := Pointer(Adapter);

    Ncb.ncb_length := SizeOf(TAdapterStatus);
    RetCode        := Netbios(Ncb);
    //---- calc _systemId from mac-address[2-5] XOR mac-address[1]...
    if (RetCode = chr(0)) or (RetCode = chr(6)) then
    begin
      _SystemId := IntToHex(Ord(Adapter.adapter_address[0]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[1]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[2]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[3]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[4]), 2) + '-' +
        IntToHex(Ord(Adapter.adapter_address[5]), 2);
    end;
    Inc(i);
    mac_list.Add(IntToStr(i)+'='+_SystemID);
//  until (I >= Ord(Lenum.Length)) or (_SystemID <> '00-00-00-00-00-00');
    until (I >= Ord(Lenum.Length));
  FreeMem(NCB);
  FreeMem(Adapter);
  FreeMem(Lenum);
  result := _SystemID;
end;
 
 
function ICMPPing(Ip : DWORD) : boolean;  
var  
 Handle : THandle;  
 DW : DWORD;  
 rep : array[1..128] of byte;  
begin  
  result := false;  
  Handle := IcmpCreateFile;  
  if Handle = INVALID_HANDLE_VALUE then Exit;  
  DW := IcmpSendEcho(Handle, in_addr(Ip), nil, 0, nil, @rep, 128, 0);  
  Result := (DW <> 0);  
  IcmpCloseHandle(Handle);  
end;  

 
function ping(host:string; var hopCount, RTT:DWORD; var ipAd:string):DWORD;  
var ip: DWORD;  
begin  
  result:=0;  
  hopCount:=0;  
  RTT:=0;  
  ipAd := GetIPAddress(host);  
  ip := inet_addr(@ipAd[1]);  
  if IcmpPing(ip) then  
    (if not GetRTTAndHopCount(ip, @hopCount, 30, @RTT) then result:=GetLastError)  
  else Result := GetLastError;  
end;  

 
function PingDW(ip: dword):integer;  
var hopCount, RTT:DWORD;  
begin  
  result := -1;  
  if IcmpPing(ip) then  
    if GetRTTAndHopCount(ip, @hopCount, 30, @RTT) then  
     result:=RTT;  
end;  

 
function DNSNameToIp(host: string):DWORD;  
begin  
  host := GetIPAddress(host);  
  result := inet_addr(@host[1]);  
end;  


end.
